'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
var WS_CONNECTED = exports.WS_CONNECTED = 'connection/WS_CONNECTED';
var WS_DISCONNECTED = exports.WS_DISCONNECTED = 'connection/WS_DISCONNECTED';
var SET_WS_CONNECTING = exports.SET_WS_CONNECTING = 'connection/SET_WS_CONNECTING';
var RPC_STATUS_UPDATE = exports.RPC_STATUS_UPDATE = 'connection/RPC_STATUS_UPDATE';
var SET_RPC_STATUS_CALLBACK = exports.SET_RPC_STATUS_CALLBACK = 'connection/SET_RPC_STATUS_CALLBACK';

var FETCH_USER_REQUEST = exports.FETCH_USER_REQUEST = 'FETCH_USER_REQUEST';
var FETCH_USER_COMPLETE = exports.FETCH_USER_COMPLETE = 'FETCH_USER_COMPLETE';
var FETCH_USER_ERROR = exports.FETCH_USER_ERROR = 'FETCH_USER_ERROR';

var ACCOUNT_SIGNUP_REQUEST = exports.ACCOUNT_SIGNUP_REQUEST = 'ACCOUNT_SIGNUP_REQUEST';
var ACCOUNT_SIGNUP_COMPLETE = exports.ACCOUNT_SIGNUP_COMPLETE = 'ACCOUNT_SIGNUP_COMPLETE';
var ACCOUNT_SIGNUP_ERROR = exports.ACCOUNT_SIGNUP_ERROR = 'ACCOUNT_SIGNUP_ERROR';
var ACCOUNT_LOGIN_REQUEST = exports.ACCOUNT_LOGIN_REQUEST = 'ACCOUNT_LOGIN_REQUEST';
var ACCOUNT_LOGIN_COMPLETE = exports.ACCOUNT_LOGIN_COMPLETE = 'ACCOUNT_LOGIN_COMPLETE';
var ACCOUNT_LOGIN_ERROR = exports.ACCOUNT_LOGIN_ERROR = 'ACCOUNT_LOGIN_ERROR';
var ACCOUNT_LOCK_WALLET = exports.ACCOUNT_LOCK_WALLET = 'ACCOUNT_LOCK_WALLET';
var ACCOUNT_UNLOCK_WALLET = exports.ACCOUNT_UNLOCK_WALLET = 'ACCOUNT_UNLOCK_WALLET';
var ACCOUNT_BRAINKEY_BACKUP = exports.ACCOUNT_BRAINKEY_BACKUP = 'ACCOUNT_BRAINKEY_BACKUP';
var SET_ACCOUNT_USER_DATA = exports.SET_ACCOUNT_USER_DATA = 'SET_ACCOUNT_USER_DATA';
var ACCOUNT_LOGOUT = exports.ACCOUNT_LOGOUT = 'ACCOUNT_LOGOUT';
var FETCH_CURRENT_USER_REQUEST = exports.FETCH_CURRENT_USER_REQUEST = 'FETCH_CURRENT_USER_REQUEST';
var FETCH_CURRENT_USER_COMPLETE = exports.FETCH_CURRENT_USER_COMPLETE = 'FETCH_CURRENT_USER_COMPLETE';
var FETCH_CURRENT_USER_ERROR = exports.FETCH_CURRENT_USER_ERROR = 'FETCH_CURRENT_USER_ERROR';
var CLEAR_CURRENT_USER_DATA = exports.CLEAR_CURRENT_USER_DATA = 'CLEAR_CURRENT_USER_DATA';
var CLEAR_CURRENT_USER_WALLET_DATA = exports.CLEAR_CURRENT_USER_WALLET_DATA = 'CLEAR_CURRENT_USER_WALLET_DATA';

var FETCH_USER_OPERATIONS_REQUEST = exports.FETCH_USER_OPERATIONS_REQUEST = 'FETCH_USER_OPERATIONS_REQUEST';
var FETCH_USER_OPERATIONS_COMPLETE = exports.FETCH_USER_OPERATIONS_COMPLETE = 'FETCH_USER_OPERATIONS_COMPLETE';
var FETCH_USER_OPERATIONS_ERROR = exports.FETCH_USER_OPERATIONS_ERROR = 'FETCH_USER_OPERATIONS_ERROR';
var UNSUBSCRIBE_FROM_USER_OPERATIONS = exports.UNSUBSCRIBE_FROM_USER_OPERATIONS = 'UNSUBSCRIBE_FROM_USER_OPERATIONS';
var SUBSCRIBE_TO_USER_OPERATIONS = exports.SUBSCRIBE_TO_USER_OPERATIONS = 'SUBSCRIBE_TO_USER_OPERATIONS';
var ADD_USER_OPERATION = exports.ADD_USER_OPERATION = 'ADD_USER_OPERATION';
var RESET_OPERATIONS = exports.RESET_OPERATIONS = 'RESET_OPERATIONS';

var FETCH_ASSETS_REQUEST = exports.FETCH_ASSETS_REQUEST = 'FETCH_ASSETS_REQUEST';
var FETCH_ASSETS_COMPLETE = exports.FETCH_ASSETS_COMPLETE = 'FETCH_ASSETS_COMPLETE';
var FETCH_ASSETS_ERROR = exports.FETCH_ASSETS_ERROR = 'FETCH_ASSETS_ERROR';
var FETCH_DEFAULT_ASSETS_REQUEST = exports.FETCH_DEFAULT_ASSETS_REQUEST = 'FETCH_DEFAULT_ASSETS_REQUEST';
var FETCH_DEFAULT_ASSETS_COMPLETE = exports.FETCH_DEFAULT_ASSETS_COMPLETE = 'FETCH_DEFAULT_ASSETS_COMPLETE';
var FETCH_DEFAULT_ASSETS_ERROR = exports.FETCH_DEFAULT_ASSETS_ERROR = 'FETCH_DEFAULT_ASSETS_ERROR';

var SAVE_DEFAULT_ASSETS_IDS = exports.SAVE_DEFAULT_ASSETS_IDS = 'SAVE_DEFAULT_ASSETS_IDS';

var FETCH_MARKET_HISTORY_REQUEST = exports.FETCH_MARKET_HISTORY_REQUEST = 'FETCH_MARKET_HISTORY_REQUEST';
var FETCH_MARKET_HISTORY_COMPLETE = exports.FETCH_MARKET_HISTORY_COMPLETE = 'FETCH_MARKET_HISTORY_COMPLETE';
var FETCH_MARKET_HISTORY_ERROR = exports.FETCH_MARKET_HISTORY_ERROR = 'FETCH_MARKET_HISTORY_ERROR';
var UPDATE_MARKET_PRICE = exports.UPDATE_MARKET_PRICE = 'UPDATE_MARKET_PRICE';
var SUB_TO_MARKET_COMPLETE = exports.SUB_TO_MARKET_COMPLETE = 'SUB_TO_MARKET_COMPLETE';
var UNSUB_FROM_MARKET_COMPLETE = exports.UNSUB_FROM_MARKET_COMPLETE = 'UNSUB_FROM_MARKET_COMPLETE';

var TRANSFER_ASSET_REQUEST = exports.TRANSFER_ASSET_REQUEST = 'TRANSFER_ASSET_REQUEST';
var TRANSFER_ASSET_ERROR = exports.TRANSFER_ASSET_ERROR = 'TRANSFER_ASSET_ERROR';
var TRANSFER_ASSET_COMPLETE = exports.TRANSFER_ASSET_COMPLETE = 'TRANSFER_ASSET_COMPLETE';
var UPDATE_PENDING_ORDERS = exports.UPDATE_PENDING_ORDERS = 'UPDATE_PENDING_ORDERS';
var SET_PENDING_DISTRIBUTION = exports.SET_PENDING_DISTRIBUTION = 'SET_PENDING_DISTRIBUTION';
var REMOVE_PENDING_DISTRIBUTION = exports.REMOVE_PENDING_DISTRIBUTION = 'REMOVE_PENDING_DISTRIBUTION';
var RESET_PENDING_ORDERS = exports.RESET_PENDING_ORDERS = 'RESET_PENDING_ORDERS';
var PROCESS_PENDING_ORDERS_REQUEST = exports.PROCESS_PENDING_ORDERS_REQUEST = 'PROCESS_PENDING_ORDERS_REQUEST';
var PROCESS_PENDING_ORDERS_COMPLETE = exports.PROCESS_PENDING_ORDERS_COMPLETE = 'PROCESS_PENDING_ORDERS_COMPLETE';
var PROCESS_PENDING_ORDERS_ERROR = exports.PROCESS_PENDING_ORDERS_ERROR = 'PROCESS_PENDING_ORDERS_ERROR';
var PROCESS_PENDING_ORDERS_SELL_COMPLETE = exports.PROCESS_PENDING_ORDERS_SELL_COMPLETE = 'PROCESS_PENDING_ORDERS_SELL_COMPLETE';

var FETCH_FEES = exports.FETCH_FEES = 'FETCH_FEES';

var SET_PENDING_TRANSFER = exports.SET_PENDING_TRANSFER = 'SET_PENDING_TRANSFER';

var STORE_BACKUP_DATE = exports.STORE_BACKUP_DATE = 'STORE_BACKUP_DATE';

var FETCH_OPENLEDGER_DEPOSIT_ADDRESS_REQUEST = exports.FETCH_OPENLEDGER_DEPOSIT_ADDRESS_REQUEST = 'FETCH_OPENLEDGER_DEPOSIT_ADDRESS_REQUEST';
var FETCH_OPENLEDGER_DEPOSIT_ADDRESS_COMPLETE = exports.FETCH_OPENLEDGER_DEPOSIT_ADDRESS_COMPLETE = 'FETCH_OPENLEDGER_DEPOSIT_ADDRESS_COMPLETE';
var FETCH_OPENLEDGER_DEPOSIT_ADDRESS_ERROR = exports.FETCH_OPENLEDGER_DEPOSIT_ADDRESS_ERROR = 'FETCH_OPENLEDGER_DEPOSIT_ADDRESS_ERROR';

var FETCH_OPENLEDGER_COINS_REQUEST = exports.FETCH_OPENLEDGER_COINS_REQUEST = 'FETCH_OPENLEDGER_COINS_REQUEST';
var FETCH_OPENLEDGER_COINS_COMPLETE = exports.FETCH_OPENLEDGER_COINS_COMPLETE = 'FETCH_OPENLEDGER_COINS_COMPLETE';
var FETCH_OPENLEDGER_COINS_ERROR = exports.FETCH_OPENLEDGER_COINS_ERROR = 'FETCH_OPENLEDGER_COINS_ERROR';

var FETCH_PRICES_HISTORY_REQUEST = exports.FETCH_PRICES_HISTORY_REQUEST = 'FETCH_PRICES_HISTORY_REQUEST';
var FETCH_PRICES_HISTORY_COMPLETE = exports.FETCH_PRICES_HISTORY_COMPLETE = 'FETCH_PRICES_HISTORY_COMPLETE';
var FETCH_PRICES_HISTORY_ERROR = exports.FETCH_PRICES_HISTORY_ERROR = 'FETCH_PRICES_HISTORY_ERROR';

var SET_CALLBACK = exports.SET_CALLBACK = 'SET_CALLBACK';
var SET_OP_CALLBACK = exports.SET_OP_CALLBACK = 'SET_OP_CALLBACK';

var SET_ORDER_DATA = exports.SET_ORDER_DATA = 'SET_ORDER_DATA';
var SET_TRX_DATA = exports.SET_TRX_DATA = 'SET_TRX_DATA';
var SET_PASSWORD_LONGIN_KEY = exports.SET_PASSWORD_LONGIN_KEY = 'SET_PASSWORD_LONGIN_KEY';

var SET_MARKET_STATS = exports.SET_MARKET_STATS = 'SET_MARKET_STATS';

var SET_KEYS = exports.SET_KEYS = 'SET_KEYS';

var SET_PASSWORD_KEY = exports.SET_PASSWORD_KEY = 'SET_PASSWORD_KEY';

var SET_AES_PRIVATE = exports.SET_AES_PRIVATE = 'SET_AES_PRIVATE';

var SET_VOTES_STATE = exports.SET_VOTES_STATE = 'SET_VOTES_STATE';

var SET_ALL_WITNESSES_COMMITTEE = exports.SET_ALL_WITNESSES_COMMITTEE = 'SET_ALL_WITNESSES_COMMITTEE';

var SET_ALL_TYPE = exports.SET_ALL_TYPE = 'SET_ALL_TYPE';

var SET_VOTE_IDS = exports.SET_VOTE_IDS = 'SET_VOTE_IDS';

var SET_GLOBAL_OBJECT = exports.SET_GLOBAL_OBJECT = 'SET_GLOBAL_OBJECT';

var set_getVoteObjects_callback = exports.set_getVoteObjects_callback = 'set_getVoteObjects_callback';

var set_publishVotes_callback = exports.set_publishVotes_callback = 'set_publishVotes_callback';

var SET_VOTE_IDS_OBJ = exports.SET_VOTE_IDS_OBJ = 'SET_VOTE_IDS_OBJ';

var SET_SETTINGS_APIS = exports.SET_SETTINGS_APIS = 'setting/SET_SETTINGS_APIS';
var SET_SELECT_WS_NODE = exports.SET_SELECT_WS_NODE = 'setting/SET_SELECT_WS_NODE';
var ADD_API_NODE = exports.ADD_API_NODE = "setting/ADD_API_NODE";
var DELETE_API_NODE = exports.DELETE_API_NODE = "setting/DELETE_API_NODE";
var SET_AUTO_RECONNECT = exports.SET_AUTO_RECONNECT = "setting/SET_AUTO_RECONNECT";
var SET_CONNECTING_URL = exports.SET_CONNECTING_URL = "setting/SET_CONNECTING_URL";

var SET_LAST_CURRENT_ASLOT = exports.SET_LAST_CURRENT_ASLOT = "SET_LAST_CURRENT_ASLOT";

var SET_ASSETS = exports.SET_ASSETS = "SET_ASSETS";

var SET_APP_KEYS = exports.SET_APP_KEYS = "SET_APP_KEYS";

var CLEAR_KEYS = exports.CLEAR_KEYS = "CLEAR_KEYS";

var CLEAR_ACCOUNT = exports.CLEAR_ACCOUNT = "CLEAR_ACCOUNT";

var SET_ONLY_GET_OP_FEE = exports.SET_ONLY_GET_OP_FEE = "SET_ONLY_GET_OP_FEE";

var SET_QUERY_ACCOUNT = exports.SET_QUERY_ACCOUNT = "SET_QUERY_ACCOUNT";